SystemOrganization addCategory: #'TP2-SistemaEjemplo-Traits'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Entities'!
SystemOrganization addCategory: #'TP2-SistemaEjemplo-Tests'!

Trait named: #TMAlo
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait1
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait2
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Trait named: #TTrait3
	uses: {}
	category: 'TP2-SistemaEjemplo-Traits'!

Object subclass: #Entity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo'!

Entity subclass: #Entity1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity subclass: #Entity2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Entity2 subclass: #Entity3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

Object subclass: #EntityMala
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Entities'!

TestCase subclass: #TestArchitecture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-SistemaEjemplo-Tests'!

!TestArchitecture methodsFor: 'asserting' stamp: 'lucas 5/16/2012 16:41'!
classInHierachyOf: class subclass: subclass

	(subclass superclass == class) ifTrue: [^ true] ifFalse: 
	[(subclass superclass == Object) ifTrue: [^false] ifFalse: [^ (self classInHierachyOf: class subclass: (subclass superclass)) ]]

! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:20'!
listClassesFrom: category
	^ SystemOrganization classesInCategory: category! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:17'!
listElementsFrom: category
	
	^((SystemOrganization listAtCategoryNamed: category) collect: [:each | Smalltalk globals at: each] )! !

!TestArchitecture methodsFor: 'accessing' stamp: 'lucas 5/16/2012 16:45'!
listTraitsFrom: category
	^((SystemOrganization listAtCategoryNamed: category) collect: [:each | Smalltalk globals at: each]) select: [ :each | each isTrait ]! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 16:16'!
testCaseCorrectlyNamed

! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 16:32'!
testEntitiesOnPackage
	| classes |
	
	classes := self listClassesFrom:   'TP2-SistemaEjemplo-Entities'.
	
	
	classes do: [:each | self assert: (self classInHierachyOf: Entity subclass: each)] 
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 16:44'!
testTraitsCorrectlyNamed
	| traitNames traits|
	
	traits := self listTraitsFrom:  'TP2-SistemaEjemplo-Traits'.
	traitNames := traits collect: [:t | t name].
	
	traitNames  do: [:tn |  self assert: $T equals: (tn first). 
		self assert: (tn size > 4) description: 'trait name must have 4 letters or more'.
		self assert: (tn second isUppercase) description: 'second letter of the trait name must be uppercase'.
		self assert: (tn third isLowercase ) description:  'third letter of the trait name must be lowercase']
	
	! !

!TestArchitecture methodsFor: 'testing' stamp: 'lucas 5/16/2012 15:37'!
traitsOnCorrectCategory
	"check if all system traits are in the correct category"
	| sysCategories categoriesWithoutTraits |
	
	sysCategories := SystemOrganization categories.
	
	Transcript show: sysCategories! !
